SystemOrganization addCategory: #'MethodName-UI'!
SystemOrganization addCategory: #'MethodName-Core'!
SystemOrganization addCategory: #'MethodName-PackageChooserUI'!
SystemOrganization addCategory: #'MethodName-PackageChooserCore'!

Association subclass: #MethodNameAssociation
	instanceVariableNames: 'print'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-Core'!

!MethodNameAssociation class methodsFor: 'as yet unclassified' stamp: ''!
key: aKey value: aValue
	^self key: aKey value: aValue print: aKey name.! !

!MethodNameAssociation class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
key: aKey value: aValue print: aString
	^(super key: aKey value: aValue) print: aString.! !

!MethodNameAssociation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize
	super initialize.
	print := String new.! !

!MethodNameAssociation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
print
	^print.! !

!MethodNameAssociation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
print: aString
	print := aString.! !

!MethodNameAssociation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
printOn: aStream

	aStream nextPutAll: (self print).! !

TextMorphForEditView subclass: #MethodNameTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-UI'!

!MethodNameTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize
	super initialize.
	self enabled! !

!MethodNameTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
keyStroke: evt
	"Handle a keystroke. Deal with navigation keys also."

	evt keyString = '<cr>'
		ifTrue: [self owner owner model searchingAccept]
		ifFalse: [super keyStroke: evt]! !

MorphTreeModel subclass: #MethodNameMorphTreeModel
	instanceVariableNames: 'tree methodNameUI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-UI'!

!MethodNameMorphTreeModel class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
on: aMethodNameUI
	^self new methodNameUI: aMethodNameUI! !

!MethodNameMorphTreeModel methodsFor: 'computing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildTree
	tree:= ((MethodNameMorphTreeMorph on: self)
				doubleClickSelector: #doubleClick;
				beSingle;
				rowInset: 4;
				columnInset: 4;
				getMenuSelector: #menu:shifted:;
				sortingSelector: #itemName;
				rowColorForEven: Color lightGray muchLighter odd: Color white).
	tree buildContents! !

!MethodNameMorphTreeModel methodsFor: 'computing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
computeTree
	self buildTree.
	^ self tree! !

!MethodNameMorphTreeModel methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
doubleClick
	| class |
	class := self selection selectedNodePath first item key.
	Browser fullOnClass: class.! !

!MethodNameMorphTreeModel methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
menu: menu shifted: b 
	menu
		add: 'Browse' translated
		target: self
		selector: #doubleClick.
	^menu! !

!MethodNameMorphTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodNameUI
	^methodNameUI! !

!MethodNameMorphTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodNameUI: aMethodNameUI
	methodNameUI:= aMethodNameUI! !

!MethodNameMorphTreeModel methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
rootItems
	^ self methodNameUI packagesList! !

!MethodNameMorphTreeModel methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
rootNodeClassFromItem: anItem
	^ MethodNameMorphTreeNodeModel! !

!MethodNameMorphTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selection: anObject
	| class |
	super selection: anObject.
	anObject selectedNodePath ifNotNilDo: [ :col | class := col first item].
	self methodNameUI selection: class.
	! !

!MethodNameMorphTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
tree
	^tree! !

MorphTreeModel subclass: #PackageChooserMorphTreeModel
	instanceVariableNames: 'model roots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-PackageChooserUI'!

!PackageChooserMorphTreeModel class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
on: aPackageChooserUI
	| instance |
	
	^self new model: aPackageChooserUI.
! !

!PackageChooserMorphTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildTree
	|tree|
	tree := (MorphTreeMorph new
				model: self;
				"pageSize: 25;"
				autoDeselection: true;
				autoMultiSelection: false;
				beMultiple;
"				rowInset: 4;"
				getMenuSelector: #menu:shifted:;
				sortingSelector: #nodeIndex;
				rowColorForEven: Color lightGray muchLighter odd: Color white).
	tree buildContents.
	^ tree! !

!PackageChooserMorphTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment
	^self model environment! !

!PackageChooserMorphTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
model
	^model! !

!PackageChooserMorphTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
model: aPackageChooserUI
	model := aPackageChooserUI! !

!PackageChooserMorphTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
rootItems
	^self model roots: self.! !

!PackageChooserMorphTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
rootNodeClassFromItem: anItem
	^PackageChooserPackageNodeModel! !

MorphTreeNodeModel subclass: #MethodNameMorphTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-UI'!

!MethodNameMorphTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
itemName
	^self item name.! !

!MethodNameMorphTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 9/1/2010 18:02'!
rowMorphForColumn: aTreeColumn
	^ self item ifNotNil: [:i | self asString asMorph] ! !

MorphTreeNodeModel subclass: #PackageChooserAbstractNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-PackageChooserUI'!

!PackageChooserAbstractNodeModel commentStamp: 'BenjaminVanRyseghem 8/24/2010 11:52' prior: 0!
This class will be usefull when the class node will be usefull :)

Instance Variables
!

PackageChooserAbstractNodeModel subclass: #PackageChooserClassNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-PackageChooserUI'!

PackageChooserAbstractNodeModel subclass: #PackageChooserPackageNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-PackageChooserUI'!

!PackageChooserPackageNodeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment
	^self model environment.! !

!PackageChooserPackageNodeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isClass
	^false.! !

!PackageChooserPackageNodeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
nodeIndex

	^self model rootItems indexOf: (self item)! !

!PackageChooserPackageNodeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selected: aBoolean
	super selected: aBoolean.
	self contents do: [:each |
		each selected = aBoolean
			ifFalse: [ each selected: aBoolean.]]! !

PluggableTextMorph subclass: #MethodNamePluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-UI'!

!MethodNamePluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^MethodNameTextMorphForEditView! !

MorphTreeMorph subclass: #MethodNameMorphTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-UI'!

!MethodNameMorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updateTree

	self updateList.
	self setSelectionIndex: 1.
	self selectionChanged.
	! !

Morph subclass: #MethodNameUI
	instanceVariableNames: 'methodName searchingTextArea sourceTextArea methodsList selectedMethodIndex packagesTree sourceCheckBox selectorsCheckBox classNamesCheckBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-UI'!

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
doAllSubscriptionsOn: aMethodName to: anInstance
	self subscribesUpdateMethodsListOn: aMethodName to: anInstance.
	self subscribesUpdatePackagesTreeOn: aMethodName to: anInstance.
	self subscribesUpdateSearchingStringOn: aMethodName to: anInstance.
	self subscribesUpdateSourceCodeOn: aMethodName to: anInstance.
	self subscribesResetEnvironmentOn: aMethodName to: anInstance.
	self subscribesUpdateCheckBoxOn: aMethodName to: anInstance.! !

!MethodNameUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
on: aMethodName
	| instance |
	instance := self new methodName: aMethodName.
	self doAllSubscriptionsOn: aMethodName to: instance.
	^instance.! !

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
subscribesResetEnvironmentOn: aMethodName to: anInstance.
	aMethodName
		when: #resetEnvironment
		send: #resetEnvironment
		to: anInstance.! !

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
subscribesUpdateCheckBoxOn: aMethodName to: anInstance.
	aMethodName
		when: #updateCheckBox
		send: #updateCheckBox
		to: anInstance.! !

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
subscribesUpdateMethodsListOn: aMethodName to: anInstance.
	aMethodName
		when: #updateMethodsList
		send: #updateMethodsList
		to: anInstance.! !

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
subscribesUpdatePackagesTreeOn: aMethodName to: anInstance.
	aMethodName
		when: #updatePackagesTree
		send: #updatePackagesTree
		to: anInstance.! !

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
subscribesUpdateSearchingStringOn: aMethodName to: anInstance.
	aMethodName
		when: #updateSearchingString
		send: #updateSearchingString
		to: anInstance.! !

!MethodNameUI class methodsFor: 'event subscriptions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
subscribesUpdateSourceCodeOn: aMethodName to: anInstance.
	aMethodName
		when: #updateSourceCode
		send: #updateSourceCode
		to: anInstance.! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllClassesButton: aWindow
	aWindow
		addMorph: self buildAllClassesButton
		frame: (0.25@0.07 extent: 0.25@0.07) 
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllItems: aWindow
	self addSearchToolBar: aWindow.
	self addAllClassesButton: aWindow.
	self addMethodsList: aWindow.
	self addPackagesTree: aWindow.
	self addSearchingTextArea: aWindow.
	self addSourceTextArea: aWindow.
	self addToolButtons: aWindow top: 0.58.
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addBrowseButton: aWindow top: aFloat
	aWindow
		addMorph: self buildBrowseButton
		frame: (0@aFloat extent: 1/6@0.07).
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addCheckBoxPart: aWindow
	self addSelectorsCheckBox: aWindow.
	self addClassNamesCheckBox: aWindow.
	self addSourceCheckBox: aWindow
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addClassNamesCheckBox: aWindow
	aWindow
		addMorph: self buildClassNamesCheckBox
		frame: ((0.4+(1/6))@0 corner: (0.4+(1/3))@0.07)
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addEnvironmentButton: aWindow
	aWindow 
		addMorph: self buildEnvironmentButton
		frame: (0@0.07 extent: 0.25@0.07) ! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addHierarchyButton: aWindow top: aFloat
	aWindow
		addMorph: self buildHierarchyButton
		frame: (5/6@aFloat extent: 1/6@0.07).
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addImplementorsButton: aWindow top: anInteger
	aWindow
		addMorph: self buildImplementorsButton
		frame: (2/6@anInteger extent: 1/6@0.07).
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addInheritanceButton: aWindow top: aFloat
	aWindow
		addMorph: self buildInheritanceButton
		frame: (2/3@aFloat extent: 1/6@0.07).
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addMethodsList: aWindow
	aWindow
		addMorph: self buildMethodsList
		frame: (0@0.14 corner: 0.5@0.58).! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addPackagesTree: aWindow
	aWindow
		addMorph: self buildPackagesTree
		frame: (0.5@0.07 corner: 1@0.58).! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSearchButton: aWindow
	aWindow 
		addMorph: self buildSearchButton
		frame: (0.9@0 extent: 0.1@0.07) ! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSearchToolBar: aWindow
	self addEnvironmentButton: aWindow.
	self addSearchButton: aWindow.
	self addCheckBoxPart: aWindow
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSearchingTextArea: aWindow
	aWindow 
		addMorph: self searchingTextArea
		frame: (0.0@0 extent: 0.4@0.07) ! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSelectorsCheckBox: aWindow
	aWindow
		addMorph: self buildSelectorsCheckBox
		frame: (0.4@0 extent: 1/6@0.07)
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSendersButton: aWindow top: aFloat
	aWindow
		addMorph: self buildSendersButton
		frame: (1/6@aFloat extent: 1/6@0.07).
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSourceCheckBox: aWindow
	aWindow
		addMorph: (self buildSourceCheckBox)
		frame: ((0.4+(1/3))@0 extent: 1/6@0.07)
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSourceTextArea: aWindow
		aWindow 
		addMorph: self sourceTextArea
		frame: (0.0@0.65 corner: 1@1) ! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addToolButtons: aWindow top: aFloat
	self addBrowseButton: aWindow top: aFloat.
	self addSendersButton: aWindow top: aFloat.
	self addImplementorsButton: aWindow top: aFloat.
	self addHierarchyButton: aWindow top: aFloat.
	self addInheritanceButton: aWindow top: aFloat.
	self addVersionButton: aWindow top: aFloat
	
	! !

!MethodNameUI methodsFor: 'items additions' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addVersionButton: aWindow top: aFloat
	aWindow
		addMorph: self buildVersionsButton
		frame: (1/2@aFloat extent: 1/6@0.07).
	
	! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allClassesButtonAction
	self methodName packagesSelection: self environment.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allClassesButtonLabel
	^'All Classes'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allClassesButtonState
	^false! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/1/2010 20:24'!
autoSelection: aText
	| list aString index interval |
	self searchingString isEmpty ifTrue: [^self].
	aString := aText asString asLowercase.
	list := self searchingString asLowercase subStrings: '*'.
	list size = 1
		ifTrue: [ | string size |
			string := list first.
			index := aString findString: string.
			size := string size.
			interval := index to: (index + size)]
		ifFalse: [ | lastIndex size |
			index := aString findString: list first.
			lastIndex := aString findString: list last.
			size := list last size.
			interval := index to: (lastIndex + size)].
		index = 0 ifFalse: [self sourceTextArea setSelection: interval]! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
beClassNames
	^ self methodName beClassNames! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
beSelectors
	^ self methodName beSelectors! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
beSource
	^ self methodName beSource! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
browse
	self selectedClass ifNotNilDo: [ :association |
		self isClassNamesSymbol
		ifTrue: [Browser fullOnClass: association key]
		ifFalse: [Browser fullOnClass: association key selector: association value selector]]! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
browseButtonAction
	self browse.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
browseButtonLabel
	^'Browse'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
browseButtonState
	^self selectedClass isNil.! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAllClassesButton
	^ PluggableButtonMorph 
			on: self 
			getState: #allClassesButtonState 
			action: #allClassesButtonAction 
			label: #allClassesButtonLabel! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAllTextArea
	self buildSearchingTextArea.
	self buildSourceTextArea.! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildBrowseButton
	^ PluggableButtonMorph 
			on: self 
			getState: #browseButtonState 
			action: #browseButtonAction 
			label: #browseButtonLabel! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildClassNamesCheckBox
	^classNamesCheckBox := (CheckboxMorph 
			on: self 
			selected: #isClassNames
			changeSelected: #beClassNames)
			font: self labelFont;
			beRadioButton;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			label: 'Class names';
			yourself! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildEnvironmentButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #environmentButtonState 
			action: #environmentButtonAction 
			label: #environmentButtonLabel)
			beSticky! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildHierarchyButton
	^ PluggableButtonMorph 
			on: self 
			getState: #hierarchyButtonState 
			action: #hierarchyButtonAction 
			label: #hierarchyButtonLabel! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildImplementorsButton
	^ PluggableButtonMorph 
			on: self 
			getState: #implementorsButtonState 
			action: #implementorsButtonAction 
			label: #implementorsButtonLabel! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildInheritanceButton
	^ (PluggableButtonMorph 
			on: self 
			getState: #inheritanceButtonState 
			action: #inheritanceButtonAction 
			label: #inheritanceButtonLabel)
			beSticky! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildMethodsList
	| list |
	list := PluggableListMorph
						on: self 
						list: #list 
						selected: #selectedMethodIndex
						changeSelected: #selectedMethodIndex:
						menu: nil
						keystroke: nil.
	self
		when: #updateMethodsList
		send: #updateList
		to: list.
	^list.! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildPackagesTree
	| tree |
	tree := (self treeConstructorClass on: self) computeTree.
	self 
		when: #updatePackagesTree
		send: #updateTree
		to: tree.
	^tree.! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSearchButton
	^ PluggableButtonMorph 
			on: self 
			getState: #searchButtonState 
			action: #searchButtonAction 
			label: #searchButtonLabel! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSearchingTextArea
	searchingTextArea := (MethodNamePluggableTextMorph
								on: self
								text: #searchingString
								accept: #searchingAccept:
								readSelection: nil
								menu: #msgPaneMenu:shifted:).! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSelectorsCheckBox
	^selectorsCheckBox := (CheckboxMorph 
			on: self 
			selected: #isSelectors 
			changeSelected: #beSelectors)
			font: self labelFont;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			label: 'Selectors';
			beRadioButton! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSendersButton
	^ PluggableButtonMorph 
			on: self 
			getState: #sendersButtonState 
			action: #sendersButtonAction 
			label: #sendersButtonLabel! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSourceCheckBox
	^sourceCheckBox := (CheckboxMorph 
			on: self 
			selected: #isSource
			changeSelected: #beSource)
			font: self labelFont;
			beRadioButton;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			label: 'Source';
			yourself! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSourceTextArea
	sourceTextArea := (PluggableTextMorph
								on: self
								text: #sourceCode
								accept: #compileSource:
								readSelection: nil
								menu: #msgPaneMenu:shifted:).

	self updateSourceCode.! !

!MethodNameUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildVersionsButton
	^ PluggableButtonMorph 
			on: self 
			getState: #versionsButtonState 
			action: #versionsButtonAction 
			label: #versionsButtonLabel! !

!MethodNameUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
changeCheckBoxColor
	sourceCheckBox
		color: Color transparent;
		borderColor: Color transparent.
	selectorsCheckBox 
		color: Color transparent;
		borderColor: Color transparent.
	classNamesCheckBox
		color: Color transparent;
		borderColor: Color transparent.
	! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
compileSource: aString
	| association class method symbol value|
	association :=  self selectedClass.
	class := association key.
	method := association value.
	symbol := class compile: (aString) classified: (method category).
	value := class methodDict at: symbol.
	association value: value.
	self changed: #sourceCode.! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultExplaination
	"The comment in the bottom pane"

	false ifTrue: [MethodFinder methodFor: #( (4 3) 7  (0 5) 5  (5 5) 10)].
		"to keep the method methodFor: from being removed from the system"

	^ 'Type a fragment of a selector in the top pane.  Accept it.

Or, use an example to find a method in the system.  Type receiver, args, and answer in the top pane with periods between the items.  3. 4. 7

Or, in this pane, use examples to find a method in the system.  Select the line of code and choose "print it".  

	MethodFinder methodFor: #( (4 3) 7  (0 5) 5  (5 5) 10).
This will discover (data1 + data2).

You supply inputs and answers and the system will find the method.  Each inner array is a list of inputs.  It contains the receiver and zero or more arguments.  For Booleans and any computed arguments, use brace notation.

	MethodFinder methodFor: { {1. 3}. true.  {20. 10}. false}.
This will discover the expressions (data1 < data2), (data2 > data1), and many others.

	MethodFinder methodFor: { {''29 Apr 1999'' asDate}. ''Thursday''.  
		{''30 Apr 1999'' asDate}. ''Friday'' }.
This will discover the expression (data1 weekday)

Receiver and arguments do not have to be in the right order.
See MethodFinder.verify for more examples.'! !

!MethodNameUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultWindowLabel
	^'Method Name'.! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment

	^ self methodName environment.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environmentButtonAction

	(PackageChooser on: self) openInWorld! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environmentButtonLabel
	^'Change environment'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environmentButtonState
	^false.! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchy
	
		self selectedClass ifNotNilDo: [ :association || selector |
			self isClassNamesSymbol 
				ifTrue: [SystemNavigation new browseHierarchy: association key]
				ifFalse: [
					selector := association value selector.
					SystemNavigation new browseHierarchy: association key selector: selector]]! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchyButtonAction
	self hierarchy.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchyButtonLabel
	^'Hierarchy'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
hierarchyButtonState
	^self selectedClass isNil.! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementors
	self isClassNamesSymbol
		ifFalse:[
			self selectedMethod ifNotNilDo: [ :selector |
		 	SystemNavigation new browseImplementorsOf: selector name: 'Implementors of ', selector asString autoSelect: nil]]! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementorsButtonAction
	self implementors.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementorsButtonLabel
	^'Implementors'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
implementorsButtonState
	^self selectedMethod isNil | self isClassNamesSymbol.! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritance
	self isClassNamesSymbol
		ifFalse: [
			self selectedClass ifNotNilDo: [ :association || selector |
			selector := association value selector.
			SystemNavigation new methodHierarchyBrowserForClass: association key selector: selector]]! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritanceButtonAction
	self inheritance.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritanceButtonLabel
	^'Inheritance'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
inheritanceButtonState
	^self selectedClass isNil | self isClassNamesSymbol.! !

!MethodNameUI methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize
	super initialize.
	selectedMethodIndex:= 0.! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isClassNames
	^ self methodName isClassNames! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isClassNamesSymbol
	^ self methodName isClassNamesSymbol! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSelectors
	^ self methodName isSelectors! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSelectorsSymbol
	^ self methodName isSelectorsSymbol! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSource
	^ self methodName isSource! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSourceSymbol
	^ self methodName isSourceSymbol! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
labelFont
	^StandardFonts defaultFont! !

!MethodNameUI methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
list
	^ self methodName methodsList! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodName
	^methodName! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodName: aMethodName
	methodName := aMethodName! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
msgPaneMenu: aMenu shifted: shifted
	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!MethodNameUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
openInWorld
	| window |
	window := StandardWindow new" setWindowColor: Color transparent".
	self buildAllTextArea.
	self addAllItems: window.
	window setLabel: self defaultWindowLabel.
	window openInWorld.
	self changeCheckBoxColor.
	self searchingTextArea keyboardFocusChange: true.
	! !

!MethodNameUI methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesList
	^ self methodName packagesList! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesSelection: aCollection
	self methodName packagesSelection: aCollection.! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
paneCOlor
	^Color transparent! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeStyler
	self sourceTextArea ifNotNilDo: [:each | each  styler: nil]! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
resetEnvironment
	self triggerEvent: #resetEnvironment! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonAction
	self searchingAccept.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonLabel
	^'Search'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonState
	^false.! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingAccept
	self searchingTextArea hasUnacceptedEdits: false.
	self methodName searchingString: (self searchingTextArea textMorph text asString).! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingAccept: aText
	self searchingTextArea hasUnacceptedEdits: false.
	self searchingString: aText asString.! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingString
	^self methodName searchingString! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingString: aString
	^self methodName searchingString: aString! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingTextArea
	^searchingTextArea! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedClass
	^ self methodName selectedClass! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedMethod
	^ self methodName selectedMethod! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedMethodIndex
	^selectedMethodIndex! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedMethodIndex: anInteger
	selectedMethodIndex := anInteger.
	self changed: #selectedMethodIndex.
	self selection: nil.
	anInteger = 0
		ifTrue: [self methodName selectedMethod: nil]
		ifFalse:[self methodName selectedMethod: (self list at: anInteger)]! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selection: aClass
	self methodName selectedClass: aClass! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
senders
	self isClassNamesSymbol
		ifFalse: [
			self selectedMethod ifNotNilDo: [ :selector |
		 	SystemNavigation new browseSendersOf: selector name: 'Senders of ', selector asString autoSelect: selector asString]].! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendersButtonAction
	self senders.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendersButtonLabel
	^'Senders'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendersButtonState
	^self selectedMethod isNil | self isClassNamesSymbol.! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 9/1/2010 20:21'!
sourceCode
	^self selectedClass isNil | self isClassNamesSymbol
		ifTrue: [
			self removeStyler.
			self defaultExplaination]
		ifFalse: [
			self useDefaultStyler.
			self sourceTextArea styler classOrMetaClass: (self selectedClass key).
			self selectedClass value getSource].! !

!MethodNameUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sourceTextArea
	^sourceTextArea! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
treeConstructorClass
	^ MethodNameMorphTreeModel! !

!MethodNameUI methodsFor: 'checkbox behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updateCheckBox
	self changed: #isSelectors.
	self changed: #isClassNames.
	self changed: #isSource! !

!MethodNameUI methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updateMethodsList
	self triggerEvent: #updateMethodsList.
	self list isEmpty ifFalse: [self selectedMethodIndex: 1].
	self updatePackagesTree.! !

!MethodNameUI methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updatePackagesTree
	self triggerEvent: #updatePackagesTree.! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updateSearchingString
	self selectedMethodIndex: 0.
	self searchingTextArea setText: self searchingString! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updateSourceCode
	| code |
	self changed: #selectedClass.
	code := self sourceCode.
	self sourceTextArea setText: code.
	((self isSourceSymbol) & (code ~~ self defaultExplaination))
		ifTrue: [ "i could implement here auto selection" 
			self autoSelection: code]! !

!MethodNameUI methodsFor: 'text areas behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
useDefaultStyler
	Smalltalk globals
		at: #SHTextStylerST80 
		ifPresent: [ :stylerClass | self sourceTextArea styler: (stylerClass new view: self sourceTextArea) ]
		ifAbsent: [ self sourceTextArea styler: ( NullTextStyler new view: self sourceTextArea) ]! !

!MethodNameUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versions
	self isClassNamesSymbol
		ifFalse: [
			self selectedClass ifNotNilDo: [ :association || selector |
			selector := association value selector.
			VersionsBrowser browseVersionsForClass: association key selector: selector]]! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versionsButtonAction
	self versions.! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versionsButtonLabel
	^'Versions'! !

!MethodNameUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
versionsButtonState
	^self selectedClass isNil | self isClassNamesSymbol.! !

Object subclass: #MethodName
	instanceVariableNames: 'searchingString selectedMethod selectedClass methodsDictionary packagesSelection checkBoxContent checkBoxSymbol environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-Core'!

!MethodName class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
MethodNameMenuOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'Method Name')
		action: [self new openInWorld];
		parent: #Tools;
		help: 'Found a method';
		icon: self icon.! !

!MethodName class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
icon
	^ThemeIcons smallInfoIcon! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
beClassNames
	self checkBoxContent: #classNames! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
beSelectors
	self checkBoxContent: #selectors! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
beSource
	self checkBoxContent: #source! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
checkBoxContent
	 ^checkBoxContent! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
checkBoxContent: aSymbol
	checkBoxContent := aSymbol.
	self changed: #isSelectors.
	self changed: #isClassNames.
	self changed: #isSource.
	self triggerEvent: #updateCheckBox.! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
checkBoxSymbol
	 ^checkBoxSymbol! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
checkBoxSymbol: aSymbol
	checkBoxSymbol := aSymbol.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
computeListOfClasses: aString
	| list result originalList |
	originalList := self packagesSelection.
	(aString includes: $*) ifFalse: [ ^originalList select: [:each | each name asLowercase = aString asLowercase]].
	list := aString subStrings: '*'.
	list isEmpty ifTrue: [ ^ originalList].
	list size = 1
		ifTrue: [
			((aString first == $*) & (aString last ~= $*))
				ifTrue: [ ^originalList select: [:each | each name asLowercase endsWith: list first asLowercase]]
				ifFalse: [
					((aString first ~= $*) & (aString last == $*))
						ifTrue: [ ^originalList select: [:each | each name asLowercase beginsWith: list first asLowercase]]
						ifFalse: [^originalList select: [:each | each name includesSubstring: list first caseSensitive: false]]]].

	result := originalList select: [:each | each name asLowercase beginsWith: list first asLowercase].
	result := result select: [:each | each name asLowercase endsWith: list last asLowercase].
	
	list do: [:each | each translateToLowercase].
	1 to: (list size -1) do: [: i | |previous next|
		previous := (list at: i).
		next := (list at: (i+1)).
		result := result select: [:each | | eachLowercase |
			eachLowercase := each name asLowercase.
			(eachLowercase findString: previous) < (eachLowercase findString: next)]].
	^result.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
computeWithMethodFinder: aString
	"Compute the selectors for the single example of receiver and args, in the very top pane" 

	| data result resultArray dataStrings mf dataObjects aa statements |
	data := aString.
	"delete t
 railing period. This should be fixed in the Parser!!"
 	[data last isSeparator] whileTrue: [data := data allButLast]. 
	data last = $. ifTrue: [data := data allButLast]. 	"Eval"
	mf := MethodFinder new.
	data := mf cleanInputs: data.	"remove common mistakes"
	[dataObjects := Compiler evaluate: '{', data, '}'] on:
SyntaxErrorNotification do: [:e | 
		self inform: 'Syntax Error: ', e errorMessage. 
		self contents: (e errorCode allButFirst allButLast).
		^#().]. "#( data1 data2 result )"
	statements := (Compiler new parse: 'zort ' , data in: Object notifying: nil)
				body statements select: [:each | (each isKindOf: ReturnNode) not].
 	dataStrings := statements collect:
				[:node | String streamContents:
					[:strm | (node isMessage) ifTrue: [strm nextPut: $(].
					node shortPrintOn: strm.
					(node isMessage) ifTrue: [strm nextPut: $)].]].
	dataObjects size < 2 ifTrue: [self inform: 'If you are giving an example of receiver, \args, and result, please put periods between the parts.\Otherwise just type one selector fragment' withCRs. ^#()].
 	dataObjects := Array with: dataObjects allButLast with: dataObjects last. "#( (data1
  data2) result )" 
	result := mf load: dataObjects; findMessage.
	(result first beginsWith: 'no single method') ifFalse: [
		aa := self testObjects: dataObjects strings: dataStrings.
		dataObjects := aa second.  dataStrings := aa third].
	resultArray := self listFromResult: result. 
	resultArray isEmpty ifTrue: [self inform: result first].

	dataStrings size = (dataObjects first size + 1) ifTrue:
		[resultArray := resultArray collect: [:expression | | newExp |
		newExp := expression.
		dataObjects first withIndexDo: [:lit :i |
			newExp := newExp copyReplaceAll: 'data', i printString
							with: (dataStrings at: i)].
		newExp, ' --> ', dataStrings last]].

 	^ resultArray! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructClassNamesDictionary
	| result listOfClasses listOfAssociations |

	listOfClasses := self computeListOfClasses: self searchingString.
	listOfAssociations := listOfClasses collect: [:class | MethodNameAssociation key: class value: nil].
	result := Dictionary new.
	result at: 'Result' put: listOfAssociations.
	self methodsDictionary: result.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructDictionary
	self searchingString isEmpty ifTrue: [ ^ self].
	self isSelectors
		ifTrue: [ ^self constructSelectorsDictionary].
	self isClassNames
		ifTrue: [ ^self constructClassNamesDictionary].
	self isSource
		ifTrue: [ ^self constructSourceDictionary].
	self error: 'Error with radio buttons'! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructDictionaryWithMessagesNameSearch: aString
	| result listOfMethods |
	
	result := Dictionary new.
	listOfMethods := self messagesNameSearch: aString.
	listOfMethods do: [:method || key value |
			key := method selector.
			value := MethodNameAssociation key: method methodClass value: method.
			(result includesKey: (key))
				ifTrue: [ (result at: (key)) add: value]
				ifFalse: [ result at: key put: (OrderedCollection new add: value; yourself)]].
	^ result.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructDictionaryWithMethodFinder: aString
	| result listOfStrings listOfSelectors |
	
	result := Dictionary new.
	listOfStrings := self computeWithMethodFinder: aString.
	listOfSelectors := listOfStrings collect: [:each | self findSelector: each].
	self packagesSelection do: [ :class | 
		class methodDict do: [: method || index |
			(( index := listOfSelectors indexOf: (method selector)) = 0) not
				ifTrue: [ | key value receiver receiverString|
					key := listOfStrings at: index.
					value := MethodNameAssociation key: method methodClass value: method.
					receiverString := (key readStream upToAll: (listOfSelectors at: index)).
					receiver := Compiler evaluate: receiverString.
					(receiver isKindOf: (value key))
						ifTrue: [value print: ('*', value print)].
					(result includesKey: (key))
						ifTrue: [ (result at: (key)) add: value]
						ifFalse: [ result at: key put: (OrderedCollection new add: value; yourself)]]]].
	^result.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructSelectorsDictionary

	self methodsDictionary: ((self searchingString includes: $.)
									ifTrue: [ self constructDictionaryWithMethodFinder: self searchingString]
									ifFalse: [ self constructDictionaryWithMessagesNameSearch: self searchingString])! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructSourceDictionary
	| result listOfMethods |
	
	result := Dictionary new.
	listOfMethods := self sourceSearch: self searchingString.
	listOfMethods do: [:method || key value |
			key := method selector.
			value := MethodNameAssociation key: method methodClass value: method.
			(result includesKey: (key))
				ifTrue: [ (result at: (key)) add: value]
				ifFalse: [ result at: key put: (OrderedCollection new add: value; yourself)]].
	self methodsDictionary: result.! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultEnvironment
	 ^ Smalltalk allClasses.! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultPackagesSelection
	 ^ self environment! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defaultString
	^''! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
defautlPackagesSelection
	 ^ self environment! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment

	 ^ environment! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment: aCollection
	 ^ aCollection! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
findSelector: aString
	"Answer the selector of aString."

	| example tokens |
	example := aString.
	tokens := Scanner new scanTokens: example.
	tokens size = 1 ifTrue: [^ tokens first].
	tokens first == #'^' ifTrue: [^ nil].
	(tokens second includes: $:) ifTrue: [^ example findSelector].
	Symbol hasInterned: tokens second ifTrue: [:aSymbol | ^ aSymbol].
	^ nil! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize
	super initialize.
	searchingString := self defaultString.
	environment := self defaultEnvironment.
	packagesSelection := self defaultPackagesSelection.
	methodsDictionary := Dictionary new.
	self initializeCheckBox.
	"SystemChangeNotifier uniqueInstance
		notify: self 
		ofSystemChangesOfItem: #category
		using: #resetEnvironment"! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initializeCheckBox
	self checkBoxContent: #selectors.! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isClassNames.
	^ self checkBoxContent == #classNames! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isClassNamesSymbol
	^ self checkBoxSymbol == #classNames! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSelectors
	^ self checkBoxContent == #selectors! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSelectorsSymbol
	^ self checkBoxSymbol == #selectors! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSource
	^ self checkBoxContent == #source! !

!MethodName methodsFor: 'checkbox' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isSourceSymbol
	^ self checkBoxSymbol == #source! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
listFromResult: resultOC
	"ResultOC is of the form #('(data1 op data2)' '(...)'). Answer a sorted array."

	(resultOC first beginsWith: 'no single method') ifTrue: [^ #()].
	^ resultOC sortBy: [:a :b | 
		(a copyFrom: 6 to: a size) < (b copyFrom: 6 to: b size)].
! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
messagesNameSearch: aString
	| list result originalList |
	originalList := self packagesSelection.
	result := OrderedCollection new.
	(aString includes: $*) ifFalse: [originalList do: [:class || temp |
						temp := class methodDict select: [:method | (method selector asString) asLowercase = aString asLowercase].
						result addAll: temp].
					^result].
	list := aString subStrings: '*'.
	list isEmpty ifTrue: [ ^ originalList].
	list size = 1
		ifTrue: [
			((aString first == $*) & (aString last ~= $*))
				ifTrue: [ 
					originalList do: [:class || temp |
						temp := class methodDict select: [:method | (method selector asString) asLowercase endsWith: list first asLowercase].
						result addAll: temp].
					^result]
				ifFalse: [
					((aString first ~= $*) & (aString last == $*))
						ifTrue: [ 
							originalList do: [:class || temp |
								temp := class methodDict select: [:method | (method selector asString) asLowercase beginsWith: list first asLowercase].
								result addAll: temp].
							^result]
						ifFalse: [
							originalList do: [:class || temp |
								temp := class methodDict select: [:method | (method selector asString) includesSubstring: list first caseSensitive: false].
								result addAll: temp].
							^result]]].

	originalList do: [:class || temp |
		temp := class methodDict select: [:method | (method selector asString) asLowercase endsWith: list first asLowercase].
		result addAll: temp].
	result := result select: [:each | each selector asLowercase endsWith: list last asLowercase].
	list do: [:each | each translateToLowercase].
	1 to: (list size -1) do: [: i | |previous next|
		previous := (list at: i).
		next := (list at: (i+1)).
		result := result select: [:each | | eachLowercase |
			eachLowercase := each selector asLowercase.
			(eachLowercase findString: previous) < (eachLowercase findString: next)]].
	^result.! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodsDictionary
	^methodsDictionary! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodsDictionary: aDictionary
	methodsDictionary := aDictionary.
	self triggerEvent: #updateMethodsList.! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodsList
	^self methodsDictionary keys sort: [:m1 :m2 | m1 name < m2 name].! !

!MethodName methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
openInWorld

	(self uiClass on:self) openInWorld.! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesList
	^self methodsDictionary at: self selectedMethod ifAbsent: [OrderedCollection new].! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesSelection
	^packagesSelection! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesSelection: aCollection
	packagesSelection :=  aCollection.
	self constructDictionary.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
resetEnvironment
	self environment: self defaultEnvironment.
	self triggerEvent: #resetEnvironment.! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingString
	 ^searchingString! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingString: aString
	searchingString := aString.
	self triggerEvent: #updateSearchingString.
	self checkBoxSymbol: self checkBoxContent.
	self constructDictionary.! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedClass
	^selectedClass! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedClass: aClass
	selectedClass := aClass.
	self triggerEvent: #updateSourceCode.
	! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedMethod
	^selectedMethod! !

!MethodName methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedMethod: aMethod
	selectedMethod := aMethod.
	self triggerEvent: #updatePackagesTree.
	! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sourceSearch: aString
	| list result originalList |
	originalList := self packagesSelection.
	result := OrderedCollection new.
	list := aString subStrings: '*'.
	
	originalList do: [:class || temp |
		temp := class methodDict select: [:method | (method getSource asString) includesSubstring: list first caseSensitive: false].
		result addAll: temp].
	list isEmpty | list size = 1
		ifTrue: [ ^ result].

	list do: [:each | each translateToLowercase].
	1 to: (list size -1) do: [: i | |previous next|
		previous := (list at: i).
		next := (list at: (i+1)).
		result := result select: [:each | | eachLowercase |
			eachLowercase := each getSource asString asLowercase.
			(eachLowercase findString: previous) < (eachLowercase findString: next)]].
	^result.! !

!MethodName methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
testObjects: dataObjects strings: dataStrings
	| dataObjs dataStrs selectors classes didUnmodifiedAnswer |
	"Try to make substitutions in the user's inputs and search for the selector again.
1 no change to answer.
2 answer Array -> OrderedCollection.
2 answer Character -> String
4 answer Symbol or String of len 1 -> Character
	For each of these, try straight, and try converting args:
Character -> String
Symbol or String of len 1 -> Character
	Return array with result, dataObjects, dataStrings.  Don't ever do a find on the same set of data twice."

dataObjs := dataObjects.  dataStrs := dataStrings.
selectors := {#asString. #first. #asOrderedCollection}.
classes := {Character. String. Array}.
didUnmodifiedAnswer := false.
selectors withIndexDo: [:ansSel :ansInd | | do result ds answerMod | "Modify the answer object"
	answerMod := false.
	do := dataObjs copyTwoLevel.  ds := dataStrs copy.
	(dataObjs last isKindOf: (classes at: ansInd)) ifTrue: [
		((ansSel ~~ #first) or: [dataObjs last size = 1]) ifTrue: [
			do at: do size put: (do last perform: ansSel).	"asString"
			ds at: ds size put: ds last, ' ', ansSel.
			result := MethodFinder new load: do; findMessage.
			(result first beginsWith: 'no single method') ifFalse: [
				"found a selector!!"
				^ Array with: result first with: do with: ds].	
			answerMod := true]].

	selectors allButLast withIndexDo: [:argSel :argInd | | dds ddo | "Modify an argument object"
			"for args, no reason to do Array -> OrderedCollection.  Identical protocol."
		didUnmodifiedAnswer not | answerMod ifTrue: [
		ddo := do copyTwoLevel.  dds := ds copy.
		dataObjs first withIndexDo: [:arg :ind |
			(arg isKindOf: (classes at: argInd))  ifTrue: [
				((argSel ~~ #first) or: [arg size = 1]) ifTrue: [
					ddo first at: ind put: ((ddo first at: ind) perform: argSel).	"asString"
					dds at: ind put: (dds at: ind), ' ', argSel.
					result := MethodFinder new load: ddo; findMessage.
					(result first beginsWith: 'no single method') ifFalse: [
						"found a selector!!"
						^ Array with: result first with: ddo with: dds]	.	
					didUnmodifiedAnswer not & answerMod not ifTrue: [
						didUnmodifiedAnswer := true].
					]]]]].
	].
^ Array with: 'no single method does that function' with: dataObjs with: dataStrs! !

!MethodName methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
uiClass
	 ^MethodNameUI! !

Object subclass: #PackageChooser
	instanceVariableNames: 'methodNameUI packagesSet selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-PackageChooserCore'!

!PackageChooser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
on: aMethodNameUI
	| instance |
	instance := self new methodNameUI: aMethodNameUI.
	
	aMethodNameUI
		when: #resetEnvironment
		send: #resetEnvironment
		to: instance.
	^instance.! !

!PackageChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
constructPackagesSet
	| list |
	list := self environment collect: [:class | class category].
	list := (list reject: [:each | each isNil]) asSet asOrderedCollection.
	list sort: [:a :b | a<b].
	^list.! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment
	^ self methodNameUI environment! !

!PackageChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize
	super initialize.
	"SystemChangeNotifier uniqueInstance
		notify: self 
		ofSystemChangesOfItem: #category 
		using: #constructPackagesSet"! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodNameUI
	^methodNameUI! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
methodNameUI: aMethodNameUI
	methodNameUI := aMethodNameUI! !

!PackageChooser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
openInWorld

	(self uiClass on: self) openInWorld! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesSet
	packagesSet isNil
		ifTrue: [packagesSet := self constructPackagesSet].
	^packagesSet! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packagesSet: aSet
	packagesSet :=  aSet.! !

!PackageChooser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
resetEnvironment
	self constructPackagesSet.

	self triggerEvent: #resetEnvironment! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selection
	^selection! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selection: aCollection
	self methodNameUI packagesSelection: aCollection! !

!PackageChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sendSelection
	self methodNameUI ifNotNilDo: [:each | each packagesSelection: self selection].! !

!PackageChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
uiClass
	^PackageChooserUI! !

Object subclass: #PackageChooserUI
	instanceVariableNames: 'model searchingTextArea searchingString searchingList allPackages selectedPackages allPackagesTree selectedPackagesTree allPackagesModel selectedPackagesModel window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodName-PackageChooserUI'!

PackageChooserUI class
	instanceVariableNames: 'sortingSelector'!

PackageChooserUI class
	instanceVariableNames: 'sortingSelector'!

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
bePackagesAndClasses	
	self sortingSelector: #packagesAndClasses.! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
bePackagesOnly
	self sortingSelector: #packagesOnly! !

!PackageChooserUI class methodsFor: 'class initialization' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize	
	self bePackagesOnly.! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isPackagesAndClasses	
	sortingSelector == #packagesAndClasses.! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
isPackagesOnly
	sortingSelector == #packagesOnly! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
on: aPackageChooser
	| instance |
	instance := self new model: aPackageChooser.
	aPackageChooser
		when: #resetEnvironment
		send: #resetEnvironment
		to: instance.

		^instance.! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
packageChooserSettingOn: aBuilder 
	<systemsettings>

	(aBuilder group: #packageChooser)
		target: self;
		parent: #codeBrowsing;
		label: 'Package Chooser' translated;
		description: 'Settings related to the Package Chooser browser' translated;
		with: [
			(aBuilder pickOne: #sortingSelector)
				target: self;
				label: 'Display' translated;
				description: 'Change the display of the browser' translated;
				domainValues: {
					'Only packages' translated -> #packagesOnly.
					"it doesn't work, i do not know why, i'll see that later !!"
				"	'Packages and classes' translated -> #packagesAndClasses."
					}]! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sortingSelector
	^sortingSelector! !

!PackageChooserUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
sortingSelector: aSelector	
	sortingSelector := aSelector.! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAddAllButton: aWindow
	aWindow
		addMorph: self buildAddAllButton
		frame: (0.45@0.4 extent: 0.1@0.1)! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAddButton: aWindow
	aWindow
		addMorph: self buildAddButton
		frame: (0.45@0.3 extent: 0.1@0.1)! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllButtonAction
	self addAllItems.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllButtonLabel
	^'>>'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllButtonState
	^false! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllItems
	| selection itemsList |
	selection := self allPackagesTree nodeList.
	itemsList := selection collect: [:each | each complexContents item].
	self allPackagesTree emptySelection.
	self selectedPackages addAll: itemsList.
	self updateAllPackages.
	self selectedPackagesTree updateList.
	self allPackagesTree updateList.! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllMorphs: aWindow
	self addTrees: aWindow.
	self addButtons: aWindow.
	self addSearchingTextArea: aWindow
	! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllPackagesTree: aWindow
	aWindow
		addMorph: self allPackagesTree
		frame: (0@0.07 corner: 0.45@0.9).! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtonAction
	self addSelectedItems.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtonLabel
	^'>'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtonState
	^false! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtons: aWindow
	self addAddButton: aWindow.
	self addRemoveButton: aWindow.
	self addAddAllButton: aWindow.
	self addRemoveAllButton: aWindow.
	self addSearchButton: aWindow.
	self addOkButton: aWindow.
	self addCancelButton: aWindow.! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addCancelButton: aWindow
	aWindow
		addMorph: self buildCancelButton
		frame: (0.9@0.9 extent: 0.1@0.1)! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addOkButton: aWindow
	aWindow
		addMorph: self buildOkButton
		frame: (0.8@0.9 extent: 0.1@0.1)! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addRemoveAllButton: aWindow
	aWindow
		addMorph: self buildRemoveAllButton
		frame: (0.45@0.5 extent: 0.1@0.1)! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addRemoveButton: aWindow
	aWindow
		addMorph: self buildRemoveButton
		frame: (0.45@0.6 extent: 0.1@0.1)! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSearchButton: aWindow
	aWindow
		addMorph: self buildSearchButton
		frame: (0.35@0 extent: 0.1@0.07)! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSearchingTextArea: aWindow
	self buildSearchingTextArea.
	aWindow
		addMorph: searchingTextArea
		frame: (0@0 extent: 0.35@0.07)! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSelectedItems
	| selection itemsList |
	selection := self allPackagesTree selectedMorphList.
	itemsList := selection collect: [:each | each complexContents item].
	self allPackagesTree emptySelection.	
	self selectedPackages addAll: itemsList.
	self updateAllPackages.
	self selectedPackagesTree updateList.
	self allPackagesTree updateList.! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addSelectedPackagesTree: aWindow
	aWindow
		addMorph: self selectedPackagesTree
		frame: (0.55@0.07 corner: 1@0.9).! !

!PackageChooserUI methodsFor: 'add items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addTrees: aWindow
	self addAllPackagesTree: aWindow.
	self addSelectedPackagesTree: aWindow.
	! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allPackages
	allPackages isNil
		ifTrue: [allPackages := self searchingList].
	^allPackages! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allPackages: aCollection
	allPackages := aCollection.
	self allPackagesTree ifNotNilDo: [:tree | tree updateList.]! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
allPackagesTree 
	^ allPackagesTree! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAddAllButton
	^PluggableButtonMorph
		on: self 
		getState: #addAllButtonState 
		action: #addAllButtonAction 
		label: #addAllButtonLabel! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAddButton
	^PluggableButtonMorph
		on: self 
		getState: #addButtonState 
		action: #addButtonAction 
		label: #addButtonLabel! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildAllPackagesTree
	| treeModel |
	treeModel :=allPackagesModel. 
	allPackagesTree:= treeModel buildTree.! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildCancelButton
	^PluggableButtonMorph
		on: self 
		getState: #cancelButtonState 
		action: #cancelButtonAction 
		label: #cancelButtonLabel! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildList: aText
	| list |
	list := self model packagesSet reject:[:each |  self selectedPackages includes: each].
	self searchingList: (self computeString: (aText asString) originalList: list)! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildOkButton
	^PluggableButtonMorph
		on: self 
		getState: #okButtonState 
		action: #okButtonAction 
		label: #okButtonLabel! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildRemoveAllButton
	^PluggableButtonMorph
		on: self 
		getState: #removeAllButtonState 
		action: #removeAllButtonAction 
		label: #removeAllButtonLabel! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildRemoveButton
	^PluggableButtonMorph
		on: self 
		getState: #removeButtonState 
		action: #removeButtonAction 
		label: #removeButtonLabel! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSearchButton
	^PluggableButtonMorph
		on: self 
		getState: #searchButtonState 
		action: #searchButtonAction 
		label: #searchButtonLabel! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSearchingTextArea
	searchingTextArea := (MethodNamePluggableTextMorph
								on: self
								text: #searchingString
								accept: #searchingString:
								readSelection: nil
								menu: #msgPaneMenu:shifted:).! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildSelectedPackagesTree
	| treeModel |
	treeModel := selectedPackagesModel. 
	selectedPackagesTree:= treeModel buildTree.! !

!PackageChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
buildTrees
	self buildAllPackagesTree.
	self buildSelectedPackagesTree.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
cancel
	self delete.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
cancelButtonAction
	self cancel.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
cancelButtonLabel
	^'Cancel'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
cancelButtonState
	^false! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
collectFromPackages	
		
	^Smalltalk allClasses select: [ :class | self selectedPackages includes: class category ].! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
computeString: aString originalList: originalList
	| list result |
	aString isEmpty ifTrue: [^originalList].
	(aString includes: $*) ifFalse: [ ^originalList select: [:each | each asLowercase = aString asLowercase]].
	list := aString subStrings: '*'.
	list isEmpty ifTrue: [ ^ originalList].
	list size = 1
		ifTrue: [
			((aString first == $*) & (aString last ~= $*))
				ifTrue: [ ^originalList select: [:each | each asLowercase endsWith: list first asLowercase]]
				ifFalse: [
					((aString first ~= $*) & (aString last == $*))
						ifTrue: [ ^originalList select: [:each | each asLowercase beginsWith: list first asLowercase]]
						ifFalse: [^originalList select: [:each |each includesSubstring: list first caseSensitive: false]]]].

	result := originalList select: [:each | each asLowercase beginsWith: list first asLowercase].
	result := result select: [:each | each asLowercase endsWith: list first asLowercase].
	
	list do: [:each | each translateToLowercase].
	1 to: (list size -1) do: [: i | |previous next|
		previous := (list at: i).
		next := (list at: (i+1)).
		result := result select: [:each | | eachLowercase |
			eachLowercase := each asLowercase.
			(eachLowercase findString: previous) < (eachLowercase findString: next)]].
	^result.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
delete
	self window delete.! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
environment

	^ self model environment! !

!PackageChooserUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
initialize
	super initialize.
	selectedPackages := SortedCollection new sortBlock: [:a :b | a < b].
	allPackagesModel := (self treeClass on: self).
	selectedPackagesModel := (self treeClass on: self).
	searchingString := String new.! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
model
	^model! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
model: aPackageChooser
	model := aPackageChooser.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
msgPaneMenu: aMenu shifted: shifted
	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
okButtonAction
	self valid.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
okButtonLabel
	^'Ok'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
okButtonState
	^false! !

!PackageChooserUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
openInWorld
	self window: (StandardWindow new setLabel: 'Packages Chooser').
	self buildTrees.
	self addAllMorphs: self window.
	self window openInWorld.
	self searchingTextArea keyboardFocusChange: true.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllButtonAction
	self removeAllItems.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllButtonLabel
	^'<<'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllButtonState
	^false! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllItems
	self selectedPackages reset.
	self selectedPackagesTree emptySelection.
	self updateAllPackages.
	self selectedPackagesTree updateList.
	self allPackagesTree updateList.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeButtonAction
	self removeSelectedItems.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeButtonLabel
	^'<'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeButtonState
	^false! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeSelectedItems
	| selection itemsList |
	selection := self selectedPackagesTree selectedMorphList.
	
	itemsList := selection collect: [:each | each complexContents item].
	
	self selectedPackages removeAll: itemsList.
	self updateAllPackages.
	self selectedPackagesTree updateList.
	self allPackagesTree updateList.
	self selectedPackagesTree emptySelection.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
resetAllPackages
	| list |
	list := self model packagesSet reject:[:each |  self selectedPackages includes: each].
	self searchingList: list.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
resetEnvironment
	self resetAllPackages.
	self allPackagesTree updateList.
	self triggerEvent: #resetEnvironment.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
roots: aTree
	aTree == allPackagesModel
		ifTrue: [ ^ self allPackages].
	aTree == selectedPackagesModel
		ifTrue:[ ^ self selectedPackages].! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonAction
	self searchingAccept.! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonLabel
	^'Search'! !

!PackageChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonState
	^false! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingAccept

	self searchingString:  (self searchingTextArea textMorph text asString).! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingList 
	searchingList isNil
		ifTrue: [ self searchingList: self model packagesSet].
	^searchingList! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingList: aCollection
	searchingList := aCollection.
	self allPackages: aCollection.! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingString
	^searchingString! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingString: aString
	self searchingTextArea hasUnacceptedEdits: false.
	searchingString := aString.
	self buildList: aString.! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchingTextArea
	^searchingTextArea! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedPackages
	^ selectedPackages! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
selectedPackagesTree 
	^ selectedPackagesTree! !

!PackageChooserUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
treeClass
	^ PackageChooserMorphTreeModel! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
updateAllPackages
	| list |
	list := self searchingList reject:[:each |  self selectedPackages includes: each].
	self allPackages: list.! !

!PackageChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
valid
	self model selection: self collectFromPackages.
	self delete.! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
window
	^window! !

!PackageChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
window: aWindow
	window := aWindow.! !
PackageChooserUI initialize!
